<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Sacha Vorbeck <info@unlimited-vision.net>
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * User extension of class t3lib_parsehtml for the 'XHTML improvements vor TYPO 3.5 (sv_xhtml_improvements)'-extension
 *
 * @author	Sacha Vorbeck <info@unlimited-vision.net>
 */


class ux_t3lib_parsehtml extends t3lib_parsehtml {

	/**
	 * Processing all tags themselves
	 */
	function processTag($value,$conf,$endTag,$protected=0)	{
			// Return immediately if protected or no parameters
		if ($protected || !count($conf))	return $value;


			// OK then, begin processing for XHTML output:
			// STILL VERY EXPERIMENTAL!!
		if ($conf["xhtml"])	{
			if ($endTag)	{	// Endtags are just set lowercase right away
				$value = strtolower($value);
			} elseif (substr($value,0,2)!="<!") {	// ... and comments are ignored.
				$inValue = substr($value,1,(substr($value,-2)=="/>"?-2:-1));	// Finding inner value with out < >
				list($tagName,$tagP)=split("[[:space:]]",$inValue,2);	// Separate attributes and tagname
				$tagName = strtolower($tagName);

					// Process attributes
				$tagAttrib = $this->get_tag_attributes($tagP);
				if (!strcmp($tagName,"img") && !isset($tagAttrib[0]["alt"]))		$tagAttrib[0]["alt"]="";	// Set alt attribute for all images (not XHTML though...)
				if (!strcmp($tagName,"script") && !isset($tagAttrib[0]["type"]))	$tagAttrib[0]["type"]="text/javascript";	// Set type attribute for all script-tags
				$outA=array();
				reset($tagAttrib[0]);
				while(list($attrib_name,$attrib_value)=each($tagAttrib[0]))	{
						// Set attributes: lowercase, always in quotes, with htmlspecialchars converted.
					$outA[]=$attrib_name.'="'.htmlspecialchars($this->bidir_htmlspecialchars($attrib_value,-1)).'"';
				}
				$newTag="<".trim($tagName." ".implode(" ",$outA));
					// All tags that are standalone (not wrapping, not having endtags) should be ended with "/>"
				if (t3lib_div::inList("img,br,hr,meta,link",$tagName) || substr($value,-3)==" />")	{
					$newTag.=" />";
				} else {
					$newTag.=">";
				}

#				debug(array($value,$inValue,$tagName,$tagAttrib));
#				debug(array($value,$newTag));
				$value = $newTag;
			}
		}
		return $value;

	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sv_xhtml_improvement/class.ux_t3lib_parsehtml.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sv_xhtml_improvement/class.ux_t3lib_parsehtml.php"]);
}
?>